apiVersion: v1
kind: Service
metadata:
  name: opa
  labels:
    app: opa
spec:
  ports:
    - name: http
      port: 80
      targetPort: 8181
  selector:
    app: opa
---
apiVersion: apps/v1
kind: Deployment
metadata:
  name: opa
  labels:
    app: opa
spec:
  replicas: 1
  selector:
    matchLabels:
      app: opa
  template:
    metadata:
      labels:
        app: opa
    spec:
      containers:
        - name: opa
          image: image-name
          imagePullPolicy: IfNotPresent
          args:
            - "run"
            #- "--ignore=.*"  # exclude hidden dirs created by Kubernetes
            - "--server"
            - "/rules"
          ports:
            - containerPort: 8181
---
apiVersion: networking.k8s.io/v1
kind: Ingress
metadata:
  annotations:
    cert-manager.io/cluster-issuer: letsencrypt-prod # Necessary to generate a certificate with a trusted Root CA
    kubernetes.io/ingress.class: nginx # Necessary to automatically configure the entry point of the cluster
    nginx.ingress.kubernetes.io/enable-cors: "true"
    nginx.ingress.kubernetes.io/cors-allow-methods: "PUT, GET, POST, OPTIONS"
    nginx.ingress.kubernetes.io/cors-allow-headers: "*"
    nginx.ingress.kubernetes.io/cors-allow-origin: "*"
    nginx.ingress.kubernetes.io/cors-expose-headers: "*"
  name: policyrules
  namespace: abc-federation # The ingress must be declared in the same namespace as the target services are
spec:
  rules:
    - host: policyrules.abc-federation.gaia-x.community # At least one rule is required, with a host Header.
      http:
        paths:
          - backend:
              service:
                name: opa # The target service name
                port:
                  number: 80 # And the target port as declared inside the service
            path: / # No path routing here, just use the Host Header. You can combine multiple Hosts / pathPrefixes
            pathType: Prefix
  tls: # Here is the sensitive part for TLS certificate generation
    - hosts:
        # We indicate the Subject CN for the generated certificate. Must match the host referenced in the rules above.
        # Wildcar are possible
        - policyrules.abc-federation.gaia-x.community
      # The secret name where the generated Certificate + private key will be put.
      # THIS SECRET NAME MUST BE UNIQUE PER NAMESPACE!!!!!
      secretName: ingress-policyrules-tls
